
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#include <mpxlib.mqh>

//+------------------------------------------------------------------+
//| mode: mode selection                                             |
//|     1: mp by day                                                 |
//|     2: mp by date from file                                      |
//| filename: datetime, comma separated;                             |
//|    (2008.12.28 11:00,2008.12.29 00:00)                           |
//|    if emtpy is assumed as <symbol>.mp                            |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Aqua        //VWAP
#property indicator_width1 2
#property indicator_color2 Green       //SD1Pos
#property indicator_width2 1
#property indicator_style2 2
#property indicator_color3 Red         //SD1Neg
#property indicator_width3 1
#property indicator_style3 2
#property indicator_color4 DarkOliveGreen//SD2Pos
#property indicator_width4 1
#property indicator_style4 2
#property indicator_color5 Crimson     //SD2Neg
#property indicator_width5 1
#property indicator_style5 2
#property indicator_color6 DarkGreen   //SD3Pos
#property indicator_width6 1
#property indicator_style6 2
#property indicator_color7 FireBrick   //SD3Neg
#property indicator_width7 1
#property indicator_style7 2

//
//
//
//
//

extern bool   Show_SD1     = false;
extern bool   Show_SD2     = false;
extern bool   Show_SD3     = false;
extern bool   Show_VolMa   = true;
extern double BandsPeriod  = 20;
extern int    BandsPrice   = 8;
extern double SmoothLength = 10;
extern double SmoothPhase  = 0;
extern bool   SmoothDouble = false; 
extern double Dev1         = 1.0;
extern double Dev2         = 2.0;
extern double Dev3         = 3.0;

extern int    mode         = 1; 
extern string filename     = "";
extern int    days         = 5;
extern double ticks        = 10;
extern bool   drawText     = true;
extern bool   drawBox      = true;
extern bool   drawPOC      = true;
extern bool   drawVolume   = true;
extern bool   std1Breakout = false;
extern bool   unitBreakout = false;
extern bool   AsiaSession  = false;
extern bool   EUSession    = true;
extern bool   USASession   = false;

//
//
//
//
//

double VolMa[];
double UB1[];
double LB1[];
double UB2[];
double LB2[];
double UB3[];
double LB3[];

//
//
//
//
//

int init()
{
   
   if (Show_VolMa)
    { 
    SetIndexBuffer(0,VolMa); SetIndexStyle(0,DRAW_LINE);
    }
    else
    {
    SetIndexStyle(0,DRAW_NONE); SetIndexLabel(0,NULL);
    }
    
   if (Show_SD1)
    {
    SetIndexBuffer(1,UB1);  SetIndexStyle(1,DRAW_LINE); SetIndexLabel(1,"SD1 POS");
    SetIndexBuffer(2,LB1);  SetIndexStyle(2,DRAW_LINE); SetIndexLabel(2,"SD1 NEG");
    }
    else
    {
    SetIndexStyle(1,DRAW_NONE); SetIndexLabel(1,NULL);
    SetIndexStyle(2,DRAW_NONE); SetIndexLabel(2,NULL);
    }
    
   if (Show_SD2)
    {
    SetIndexBuffer(3,UB2);  SetIndexStyle(3,DRAW_LINE); SetIndexLabel(3,"SD2 POS");
    SetIndexBuffer(4,LB2);  SetIndexStyle(4,DRAW_LINE); SetIndexLabel(4,"SD2 NEG");
    }
    else
    {
    SetIndexStyle(3,DRAW_NONE); SetIndexLabel(3,NULL);
    SetIndexStyle(4,DRAW_NONE); SetIndexLabel(4,NULL);
    }
    
   if (Show_SD3)
    {
    SetIndexBuffer(5,UB3);  SetIndexStyle(5,DRAW_LINE); SetIndexLabel(5,"SD3 POS");
    SetIndexBuffer(6,LB3);  SetIndexStyle(6,DRAW_LINE); SetIndexLabel(6,"SD3 NEG");
    }
    else
    {
    SetIndexStyle(5,DRAW_NONE); SetIndexLabel(5,NULL);
    SetIndexStyle(6,DRAW_NONE); SetIndexLabel(6,NULL);
    }

return(0);
}

//
//
//
//
//

int deinit(){  mpxDrawErase();  return(0);}

//
//                           
//
//
//

int start()
{
    
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
      
   for(i=limit; i>=0; i--) VolMa[i] = iDSmooth(iVolMa(getPrice(BandsPrice,i),BandsPeriod,i),SmoothLength,SmoothPhase,i);  
  	for(i=limit; i>=0; i--)
  	{
  	      double StdDev = iDeviation(VolMa,BandsPeriod,i);
  	      UB1[i] = VolMa[i] + (StdDev * Dev1);
  	      LB1[i] = VolMa[i] - (StdDev * Dev1);
  	      UB2[i] = VolMa[i] + (StdDev * Dev2);
  	      LB2[i] = VolMa[i] - (StdDev * Dev2);
  	      UB3[i] = VolMa[i] + (StdDev * Dev3);
  	      LB3[i] = VolMa[i] - (StdDev * Dev3);
	}
	
	double onetick = 1/(MathPow(10,Digits)) * ticks;    
	double pocsPrices[];
   double mpxVolume[];  
    
   mpxDrawErase(); 
   int sessions = 0;    
   if (AsiaSession)
       sessions |= mpxeAsiaSession;
   if (EUSession)
       sessions |= mpxeEUSession;
   if (USASession)
       sessions |= mpxeUSASession;

   // MP  
   //
   //
   //
   //
  
   if (mode==1)
   {
    mpxMarketProfileByDay(pocsPrices, mpxVolume, Low, High, days, onetick, sessions, drawText, drawBox, drawPOC, drawVolume);
   }
   else if (mode==2)
   {
   if (filename == "")
       filename = mpxNameFromPeriod() + ".mp";
    mpxMarketProfileByFile(pocsPrices, mpxVolume, Low, High, filename, onetick, sessions, drawText, drawBox, drawPOC, drawVolume);
   }
   
   // Alert
   //
   //
   //
   //
   
   if (std1Breakout || unitBreakout)
      mpxSendMailAlert(pocsPrices, std1Breakout, unitBreakout);
	      
return(0);
}

//
//
//
//
//

double iDeviation(double& array[], int period, int pos)
{
   double dMA  = iSma(array,period,pos);
   double dSum = 0;
      for(int i=0; i<period; i++,pos++) dSum += (array[pos]-dMA)*(array[pos]-dMA);
   return(MathSqrt(dSum/period));
}

//
//
//
//
//

double iSma(double& array[], int period, int pos)
{
   double sum = 0.0;
      for(int i=0; i<period; i++,pos++) sum += array[pos];
   return(sum/period);     
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double workPrices[];
int    r;

double iVolMa(double price, int period, int i)
{
  if (ArraySize(workPrices)!= Bars) ArrayResize(workPrices,Bars);
  r = Bars-i-1;
   workPrices[r] = price;
   
   double sum  = 0;
   double sumw = 0;
  
   for(int k=0; k<period && (r-k)>=0; k++)
   { 
      double weight = Volume[i+k];
             sumw  += weight;
             sum   += weight*workPrices[r-k]; 
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7:     return((Open[i]+Close[i])/2.0);
      case 8:     return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      default :   return(iMA(NULL,0,1,0,MODE_SMA,type,i));
   }      
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, int i, int s=0)
{
   if (SmoothDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//
//
//
//
//


